/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package serveis;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.PathParam;
import javax.ws.rs.Consumes;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.Produces;

import java.sql.*;
import javax.ws.rs.QueryParam;





/**
 * REST Web Service
 *
 * @author fede
 */
@Path("resultats")
public class resultats {

    @Context
    private UriInfo context;

    //variables FEDE
        private static final String DBurl = "jdbc:mysql://BASE_DE_DADES";
    private static final String DBusuari = "USUARI";
    private static final String DBpassword = "PASSWORD";
    private static final String urlImatge = "imatges/imatge";


    
    /**
     * Creates a new instance of resultats
     */
    public resultats() {
    }

    /**
     * Retrieves representation of an instance of serveis.resultats
     * @return an instance of java.lang.String
     */
    @GET
    @Produces("application/json")
    public String getJson(@QueryParam("codiAlumne") String codiAlumne,@QueryParam("codiAutoEscola") String codiAutoEscola,@QueryParam("desde") String desde,@QueryParam("finsA") String finsA) {
        desde = desde + " 00:00:00";
        finsA = finsA + " 99:99:99";
        String resultat="{\"resultat\":";
        Connection conexion=null;        
        //System.out.println("Cercant preguntes per al alumne:" + codiAlumne);        
        
        try { Class.forName("com.mysql.jdbc.Driver");
              conexion = DriverManager.getConnection(DBurl, DBusuari, DBpassword); 
              Statement s = conexion.createStatement(); 
              // en funcio de si ens passen alumne o no, seleccionem unes dades o unes altres
              String where;
              if (codiAlumne!=null) { where = " AND (codiAlumne="+codiAlumne+") ";}
              else { where = " and (codiAlumne IN (select codiAlumne from alumnes where codiAutoEscola="+codiAutoEscola+"))"; }
              
              //preguntes
              String sql = "SELECT COUNT(*) as preguntes,SUM(resultat) as correctes FROM preguntesFetes WHERE ((dataAlta>='" + desde + "')AND(dataAlta<='" + finsA + "') " + where + ")";
              System.out.println(sql);              
              ResultSet rs1 = s.executeQuery(sql);
              if (rs1.first()) { resultat = resultat + "\"OK\",\"preguntes\":\""+rs1.getString("preguntes")+ "\"";
                                 resultat = resultat + ",\"correctes\":\"" + rs1.getString("correctes") + "\"";
                                 }
              
              //examens
              sql = "SELECT COUNT(*) as examens FROM examensFets WHERE ((data>='" + desde + "')AND(data<='" + finsA + "') " + where + ")";
              System.out.println(sql);              
              rs1 = s.executeQuery(sql);
              if (rs1.first()) { resultat = resultat + ",\"examens\":\""+rs1.getString("examens")+ "\"";
                                 }
              //examens aprobats
              sql = "SELECT COUNT(*) as examensAprobats FROM examensFets WHERE ((data>='" + desde + "')AND(data<='" + finsA + "') " + where + " AND (respostesEncertades>=5))";
              System.out.println(sql);              
              rs1 = s.executeQuery(sql);
              if (rs1.first()) { resultat = resultat + ",\"examensAprobats\":\""+rs1.getString("examensAprobats")+ "\"}";
                                 }
              }
        catch (Exception e) { System.out.println("error" + e); }
        finally { try { if (conexion != null) conexion.close();} catch (Exception e) {}}
        return resultat;

    }

    /**
     * PUT method for updating or creating an instance of resultats
     * @param content representation for the resource
     * @return an HTTP response with content of the updated or created resource.
     */
    @PUT
    @Consumes("application/json")
    public void putJson(String content) {
    }
}
