-- phpMyAdmin SQL Dump
-- version 4.0.8
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Temps de generació: 12-06-2014 a les 03:51:32
-- Versió del servidor: 5.1.67-rel14.3-log
-- Versió de PHP: 5.3.17

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de dades: `lovei_tfc`
--

-- --------------------------------------------------------

--
-- Estructura de la taula `alumnes`
--

CREATE TABLE IF NOT EXISTS `alumnes` (
  `codiAlumne` mediumint(9) NOT NULL AUTO_INCREMENT,
  `codiAutoEscola` mediumint(9) NOT NULL,
  `usuari` char(30) NOT NULL,
  `password` char(30) NOT NULL,
  `dataAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `dataUltimaConexio` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`codiAlumne`),
  KEY `codiAutoEscola` (`codiAutoEscola`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

--
-- Bolcant dades de la taula `alumnes`
--

INSERT INTO `alumnes` (`codiAlumne`, `codiAutoEscola`, `usuari`, `password`, `dataAlta`, `dataUltimaConexio`) VALUES
(8, 4, 'alumne1', '1', '2014-06-04 13:24:37', '0000-00-00 00:00:00'),
(10, 4, 'al1', '12', '2014-06-05 12:55:12', '0000-00-00 00:00:00'),
(11, 7, 'alumne11', '11', '2014-06-09 08:30:37', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Estructura de la taula `autoEscoles`
--

CREATE TABLE IF NOT EXISTS `autoEscoles` (
  `codi` mediumint(9) NOT NULL AUTO_INCREMENT,
  `usuari` char(30) NOT NULL,
  `password` char(30) NOT NULL,
  PRIMARY KEY (`codi`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

--
-- Bolcant dades de la taula `autoEscoles`
--

INSERT INTO `autoEscoles` (`codi`, `usuari`, `password`) VALUES
(4, 'fedepinet@gmail.com', 'fd'),
(7, 'autoescola1', '1');

-- --------------------------------------------------------

--
-- Estructura de la taula `examensFets`
--

CREATE TABLE IF NOT EXISTS `examensFets` (
  `codiAlumne` mediumint(9) NOT NULL,
  `comptador` mediumint(9) NOT NULL AUTO_INCREMENT,
  `data` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `respostesEncertades` mediumint(9) DEFAULT NULL,
  PRIMARY KEY (`comptador`),
  KEY `codiAlumne` (`codiAlumne`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- Bolcant dades de la taula `examensFets`
--

INSERT INTO `examensFets` (`codiAlumne`, `comptador`, `data`, `respostesEncertades`) VALUES
(8, 1, '2014-06-07 07:28:26', 2),
(11, 2, '2014-06-09 08:32:09', 2),
(11, 3, '2014-06-09 08:43:12', 3);

-- --------------------------------------------------------

--
-- Estructura de la taula `preguntes`
--

CREATE TABLE IF NOT EXISTS `preguntes` (
  `codiPregunta` mediumint(9) NOT NULL AUTO_INCREMENT,
  `pregunta` char(200) NOT NULL,
  `resposta1` char(200) NOT NULL,
  `resposta2` char(200) NOT NULL,
  `resposta3` char(200) NOT NULL,
  `resposta4` char(200) NOT NULL,
  `imatge` char(200) NOT NULL,
  `respostaCorrecta` mediumint(9) NOT NULL,
  PRIMARY KEY (`codiPregunta`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=31 ;

--
-- Bolcant dades de la taula `preguntes`
--

INSERT INTO `preguntes` (`codiPregunta`, `pregunta`, `resposta1`, `resposta2`, `resposta3`, `resposta4`, `imatge`, `respostaCorrecta`) VALUES
(1, ' ¿Qué alumbrado llevará encendido una motocicleta durante el día?', 'El de corto alcance o cruce.', 'El de posición o el de corto alcance.', 'Ninguno.', '-', 'imatgePregunta1.jpg', 1),
(2, '¿Puede realizar un cambio de sentido en un lugar donde esté prohibido adelantar?', 'Sí, excepto entre la puesta y la salida de sol, porque disminuye la visibilidad.', 'No, salvo que el cambio de sentido esté expresamente autorizado.', 'Sí, cuando la circulación en sentido contrario lo permita.', '-', 'imatgePregunta2.jpg', 2),
(3, 'En una autopista conduciendo un camión de 3.000 Kg. de M.M.A., ¿qué distancia es obligatorio dejar con el vehículo que va delante?', '100 metros.', '50 metros.', 'La distancia de seguridad.', '-', 'imatgeNeutra.jpg', 3),
(4, '¿Dónde está permitido que viaje un niño que no alcance los 135 centímetros de estatura?', 'En cualquiera de los asientos traseros utilizando el cinturón para adultos.', 'En un asiento delantero o trasero, utilizando siempre el cinturón de seguridad para adultos.', 'En un asiento delantero o trasero utilizando siempre un dispositivo de retención homologado en función de su talla y peso.', '-', 'imatgePregunta4.jpg', 3),
(5, 'Con esta señalización, ¿a qué velocidad debe circular?', 'Obligatoriamente a 30 km/h.', 'Al menos a 30 km/h.', 'A 30 km/h, como recomendación, durante el tramo que subsista el peligro.', '-', 'imatgePregunta5.jpg', 3),
(6, 'Una línea blanca continua sobre la calzada, sensiblemente más ancha que en el caso general...', 'indica la existencia de un carril especial.', 'sirve para delimitar, únicamente, los carriles bus.', 'indica el borde de la calzada.', '-', 'imatgePregunta6.jpg', 1),
(7, 'El seguro obligatorio, ¿cubre los daños en la persona del conductor del vehículo asegurado?', 'Sí, en todo caso.', 'Sí, salvo cuando el conductor es el tomador del seguro.', 'No.', '-', 'imatgeNeutra.jpg', 3),
(8, 'La mayor parte de las víctimas mortales por accidente de circulación se producen en...', 'vías interurbanas.', 'vías urbanas.', 'travesías.', '-', 'imatgePregunta8.jpg', 1),
(9, '¿Cuántos espejos retrovisores tienen que llevar instalados las motocicletas?', 'Obligatoriamente uno en el lado derecho, pero pueden llevar dos.', 'Siempre deben llevar dos espejos, uno en cada lado.', 'Un espejo exterior izquierdo si no superan los 100 km/h y dos, uno en cada lado, si la velocidad es mayor.', '-', 'imatgePregunta9.jpg', 3),
(10, '¿Está permitida la circulación de animales por una carretera convencional?', 'Sí, únicamente cuando no exista vía pecuaria.', 'No.', 'Sí, excepto cuando circulen en rebaño.', '-', 'imatgePregunta10.jpg', 1),
(11, 'El conductor debe...', 'observar únicamente a los conductores que se aproximan por detrás.', 'mirar siempre hacia adelante.', 'observar constantemente lo que sucede en la vía.', '-', 'imatgeNeutra.jpg', 3),
(12, '¿Cuál es la tasa de alcohol máxima permitida a un conductor novel?', '0,25 miligramos de alcohol por litro de aire espirado.', '0,3 miligramos de alcohol por litro de aire espirado.', '0,15 miligramos de alcohol por litro de aire espirado.', '-', 'imatgeNeutra.jpg', 3),
(13, 'Cuando un vehículo accidentado comienza a arder, ¿qué se debe hacer primero?', 'Apagar el fuego.', 'Sacar rápidamente a los heridos.', 'Ir a buscar ayuda.', '-', 'imatgePregunta13.jpg', 2),
(14, 'En esta situación, ¿qué debe hacer si va a girar a la izquierda?', 'Continuar, obedeciendo al semáforo de la derecha.', 'Detenerse, obedeciendo al semáforo situado a la izquierda.', 'Sólo detenerse si hay peatones cruzando.', '-', 'imatgePregunta14.jpg', 2),
(15, '¿Está permitido colocar los triángulos de preseñalización de peligro a menos de 50 metros del vehículo averiado?', 'Sí, a esa distancia ya son visibles.', 'No, deben estar al menos a 100 metros.', 'No.', '-', 'imatgePregunta15.jpg', 3),
(16, 'Para entrar en una autopista, ¿a qué velocidad debe circular?', 'A la máxima velocidad permitida en la autopista.', 'Siempre muy despacio para entrar con seguridad.', 'A la velocidad adecuada que permita incorporarse con seguridad.', '-', 'imatgeNeutra.jpg', 3),
(17, '¿Qué es una detención?', 'La inmovilización del vehículo por necesidades de la circulación.', 'Una parada por cualquier causa.', 'Un estacionamiento sin bajarse del vehículo.', '-', 'imatgeNeutra.jpg', 1),
(18, 'Esta señal indica peligro por la proximidad de...', 'una vía en mal estado.', 'un badén en la vía.', 'un resalto en la vía.', '-', 'imatgePregunta18.jpg', 2),
(19, 'La velocidad adecuada está siempre...', 'por debajo de la velocidad mínima.', 'por encima de la velocidad máxima y por debajo de la mínima.', 'por encima de la velocidad mínima y por debajo de la máxima.', '-', 'imatgePregunta19.jpg', 3),
(20, '¿Tiene alguna obligación cuando su vehículo va a ser adelantado?', 'Sí, señalizar con el intermitente derecho para indicar que puede realizar la maniobra con seguridad.', 'No, la responsabilidad es del vehículo que adelanta.', 'Sí, ceñirse al borde derecho de la calzada para facilitar la maniobra.', '-', 'imatgeNeutra.jpg', 3),
(21, 'Entre otros efectos, el consumo de alcohol...', 'mejora la atención si se toma en pequeñas cantidades.', 'aumenta las distracciones al volante.', 'ayuda a mantener la atención al volante.', '-', 'imatgePregunta21.jpg', 2),
(22, 'El funcionamiento del airbag, ¿puede llegar a ser peligroso en un accidente?', 'Sí, siempre.', 'Sí, si no se lleva puesto el cinturón de seguridad.', 'No.', '-', 'imatgeNeutra.jpg', 2),
(23, '¿Cuál debe ser su comportamiento al ceder el paso?', 'Detenerse en las intersecciones si se acerca otro vehículo.', 'Parar y comprobar si otro usuario de la vía tiene prioridad.', 'No obligar al vehículo que tiene prioridad a modificar bruscamente su trayectoria o velocidad.', '-', 'imatgePregunta23.jpg', 3),
(24, '¿A qué velocidad máxima tiene permitido circular una autocaravana en una autovía?', 'A 100 km/h.', 'A 90 km/h.', 'A 100 km/h, pudiendo superarla en 20 km/h para adelantar.', '-', 'imatgePregunta24.jpg', 1),
(25, 'La fatiga, ¿provoca lentitud y falta de precisión en los movimientos?', 'No, la fatiga sólo produce calambres.', 'No.', 'Sí, por lo cual la conducción se hace más peligrosa.', '-', 'imatgePregunta25.jpg', 3),
(26, 'La tasa máxima de alcoholemia permitida en sangre para conductores profesionales es...', '0,30 gramos por litro.', '0,30 miligramos por litro.', '0,50 gramos por litro.', '-', 'imatgeNeutra.jpg', 1),
(27, 'Los accidentes de tráfico generan...', 'un enorme impacto económico, solamente.', 'daños materiales y costes sanitarios, administrativos y humanos.', 'daños materiales y costes humanos, únicamente.', '-', 'imatgeNeutra.jpg', 2),
(28, 'El efecto submarino se produce cuando...', 'el apoyacabezas está mal regulado.', 'el cinturón de seguridad no es capaz de retener adecuadamente durante un accidente y el cuerpo se desliza por debajo de él.', 'la distancia con el airbag es incorrecta.', '-', 'imatgeNeutra.jpg', 2),
(29, 'Al auxiliar a una víctima de un accidente de tráfico, ¿debe darle alimentos o bebidas?', 'Sí, si lo piden.', 'No.', 'Alimentos no, pero bebidas sí.', '-', 'imatgePregunta29.jpg', 2),
(30, 'Fuera de poblado, ¿qué separación lateral debe dejar una motocicleta al adelantar un camión?', 'Una distancia proporcional a la velocidad a la que circule.', 'Un espacio no inferior a 1,50 metros.', 'Una separación que considere segura en función de las circunstancias del momento.', '-', 'imatgeNeutra.jpg', 2);

-- --------------------------------------------------------

--
-- Estructura de la taula `preguntesFetes`
--

CREATE TABLE IF NOT EXISTS `preguntesFetes` (
  `codiAlumne` mediumint(9) NOT NULL,
  `codiPregunta` mediumint(9) NOT NULL,
  `comptador` mediumint(9) NOT NULL AUTO_INCREMENT,
  `dataAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `respostaIntroduida` mediumint(9) NOT NULL,
  `resultat` mediumint(9) NOT NULL,
  PRIMARY KEY (`comptador`,`codiAlumne`,`codiPregunta`),
  KEY `codiAlumne` (`codiAlumne`),
  KEY `codiPregunta` (`codiPregunta`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=63 ;

--
-- Bolcant dades de la taula `preguntesFetes`
--

INSERT INTO `preguntesFetes` (`codiAlumne`, `codiPregunta`, `comptador`, `dataAlta`, `respostaIntroduida`, `resultat`) VALUES
(8, 1, 1, '2014-06-04 15:44:38', 1, 1),
(8, 1, 3, '2014-06-05 08:26:03', 1, 1),
(8, 2, 4, '2014-06-05 08:29:02', 1, 0),
(8, 2, 5, '2014-06-05 08:29:06', 1, 0),
(8, 3, 6, '2014-06-05 08:29:18', 1, 0),
(8, 3, 7, '2014-06-05 08:29:23', 3, 1),
(8, 4, 8, '2014-06-05 08:29:31', 3, 1),
(8, 4, 9, '2014-06-05 08:29:35', 1, 0),
(8, 5, 10, '2014-06-05 08:43:55', 1, 0),
(8, 6, 11, '2014-06-05 08:47:03', 1, 1),
(8, 6, 12, '2014-06-05 08:47:07', 2, 0),
(8, 7, 13, '2014-06-05 08:47:19', 2, 0),
(8, 8, 14, '2014-06-05 08:47:22', 1, 1),
(8, 9, 15, '2014-06-05 08:47:25', 2, 0),
(8, 10, 16, '2014-06-05 12:56:02', 1, 1),
(8, 11, 17, '2014-06-05 12:56:08', 3, 1),
(8, 11, 18, '2014-06-05 12:56:12', 2, 0),
(8, 12, 19, '2014-06-05 12:56:19', 3, 1),
(8, 12, 20, '2014-06-05 12:56:23', 3, 1),
(8, 13, 21, '2014-06-05 12:56:31', 2, 1),
(8, 13, 22, '2014-06-05 12:56:35', 1, 0),
(8, 14, 23, '2014-06-05 12:56:47', 2, 1),
(8, 15, 24, '2014-06-05 12:56:55', 2, 0),
(8, 16, 25, '2014-06-05 13:04:00', 3, 1),
(8, 17, 26, '2014-06-05 13:04:06', 2, 0),
(8, 18, 27, '2014-06-05 13:04:13', 2, 1),
(8, 19, 28, '2014-06-05 13:04:25', 1, 0),
(8, 20, 29, '2014-06-05 13:04:34', 1, 0),
(8, 20, 30, '2014-06-05 13:04:39', 1, 0),
(8, 21, 31, '2014-06-05 13:04:43', 1, 0),
(8, 22, 32, '2014-06-05 13:04:49', 2, 1),
(8, 23, 33, '2014-06-05 13:04:56', 3, 1),
(8, 24, 34, '2014-06-07 07:21:00', 1, 1),
(8, 25, 35, '2014-06-07 07:21:05', 3, 1),
(8, 26, 36, '2014-06-07 07:21:09', 1, 1),
(8, 27, 37, '2014-06-07 07:21:12', 1, 0),
(8, 28, 38, '2014-06-07 07:25:23', 2, 1),
(8, 29, 39, '2014-06-07 07:27:54', 1, 0),
(8, 30, 40, '2014-06-07 07:28:12', 1, 0),
(8, 16, 41, '2014-06-07 07:28:15', 2, 0),
(8, 24, 42, '2014-06-07 07:28:18', 1, 1),
(8, 8, 43, '2014-06-07 07:28:21', 3, 0),
(8, 10, 44, '2014-06-07 07:28:23', 1, 1),
(11, 1, 45, '2014-06-09 08:31:15', 3, 0),
(11, 2, 46, '2014-06-09 08:31:18', 1, 0),
(11, 3, 47, '2014-06-09 08:31:21', 1, 0),
(11, 4, 48, '2014-06-09 08:31:24', 1, 0),
(11, 4, 49, '2014-06-09 08:31:28', 2, 0),
(11, 5, 50, '2014-06-09 08:31:32', 2, 0),
(11, 6, 51, '2014-06-09 08:31:35', 1, 1),
(11, 7, 52, '2014-06-09 08:31:39', 3, 1),
(11, 8, 53, '2014-06-09 08:31:48', 1, 1),
(11, 8, 54, '2014-06-09 08:31:51', 1, 1),
(11, 9, 55, '2014-06-09 08:31:55', 2, 0),
(11, 10, 56, '2014-06-09 08:31:58', 2, 0),
(11, 11, 57, '2014-06-09 08:32:02', 2, 0),
(11, 12, 58, '2014-06-09 08:42:29', 3, 1),
(11, 12, 59, '2014-06-09 08:42:35', 3, 1),
(11, 13, 60, '2014-06-09 08:42:47', 1, 0),
(11, 14, 61, '2014-06-09 08:42:57', 2, 1),
(11, 15, 62, '2014-06-09 08:43:05', 2, 0);

--
-- Restriccions per taules bolcades
--

--
-- Restriccions per la taula `alumnes`
--
ALTER TABLE `alumnes`
  ADD CONSTRAINT `alumnes_ibfk_1` FOREIGN KEY (`codiAutoEscola`) REFERENCES `autoEscoles` (`codi`) ON DELETE CASCADE;

--
-- Restriccions per la taula `examensFets`
--
ALTER TABLE `examensFets`
  ADD CONSTRAINT `examensFets_ibfk_1` FOREIGN KEY (`codiAlumne`) REFERENCES `alumnes` (`codiAlumne`) ON DELETE CASCADE;

--
-- Restriccions per la taula `preguntesFetes`
--
ALTER TABLE `preguntesFetes`
  ADD CONSTRAINT `preguntesFetes_ibfk_1` FOREIGN KEY (`codiAlumne`) REFERENCES `alumnes` (`codiAlumne`) ON DELETE CASCADE,
  ADD CONSTRAINT `preguntesFetes_ibfk_2` FOREIGN KEY (`codiPregunta`) REFERENCES `preguntes` (`codiPregunta`) ON DELETE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
